/*
Il y a un bug dans la version 3.6 et la mthode refreshPatch. Il faut downgrader  la version 3.5 ou alors utiliser une version suprieure  la version 3.6.
*/
package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.primitives.data.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="300")]
	public class anim6 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _Mat:WireColorMaterial;
		private var _MatCube:ColorMaterial;
		private var _MatSelectedCube:ColorMaterial;

		//objects
		private var _BezierPatch:BezierPatch;
		private var _PatchVerts:Array;
		private var _VerticeZ:Number=0;
		private var _SegmentsW:Number=5;
		private var _SegmentsH:Number=5;
		private var _PatchNode:Array;

		private var _Cube1:Cube;
		private var _Cube2:Cube;
		private var _Cube3:Cube;
		private var _Cube4:Cube;
		private var _Cube5:Cube;
		private var _Cube6:Cube;
		private var _Cube7:Cube;
		private var _Cube8:Cube;
		private var _Cube9:Cube;
		private var _Cube10:Cube;
		private var _Cube11:Cube;
		private var _Cube12:Cube;
		private var _Cube13:Cube;
		private var _Cube14:Cube;
		private var _Cube15:Cube;
		private var _Cube16:Cube;

		private var _ObjectContainer3D:ObjectContainer3D;

		// Sliders		
		private var _Slider1:Slider;

		public function anim6()
		{
			initEngine();
			initMat();
			initObjects();
			initSliders();
			initListeners();
		}

		public function initMat():void
		{
			_Mat=new WireColorMaterial(0xF4661B);
			_MatCube=new ColorMaterial(0x0000ee);
			_MatSelectedCube=new ColorMaterial(0x00ee00);
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 14, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: 220, y: 210});
			_View.scene=_Scene;

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(-800, +800);
			_Slider1.setTitle("Composante Z");
			_Slider1.create();
			_Slider1.setCursorPosition(0);
		}

		private function initObjects():void
		{
			_ObjectContainer3D=new ObjectContainer3D();
			_Scene.addChild(_ObjectContainer3D);
			_ObjectContainer3D.x=70;
			_ObjectContainer3D.y=-20;

			_PatchNode=new Array();
			_PatchNode["plane"]=new Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);

			_Cube1=new Cube({width: 5, height: 5, depth: 5});
			_Cube1.material=_MatCube;
			_Cube1.x=-40;
			_Cube1.y=0;
			_Cube1.z=0;
			_Cube1.x-=20;
			_ObjectContainer3D.addChild(_Cube1);

			_Cube2=new Cube({width: 5, height: 5, depth: 5});
			_Cube2.material=_MatCube;
			_Cube2.x=-40;
			_Cube2.y=40;
			_Cube2.z=0;
			_Cube2.x-=20;
			_ObjectContainer3D.addChild(_Cube2);

			_Cube3=new Cube({width: 5, height: 5, depth: 5});
			_Cube3.material=_MatCube;
			_Cube3.x=-40;
			_Cube3.y=80;
			_Cube3.z=0;
			_Cube3.x-=20;
			_ObjectContainer3D.addChild(_Cube3);

			_Cube4=new Cube({width: 5, height: 5, depth: 5});
			_Cube4.material=_MatCube;
			_Cube4.x=-40;
			_Cube4.y=120;
			_Cube4.z=0;
			_Cube4.x-=20;
			_ObjectContainer3D.addChild(_Cube4);

			_Cube5=new Cube({width: 5, height: 5, depth: 5});
			_Cube5.material=_MatCube;
			_Cube5.x=0;
			_Cube5.y=0;
			_Cube5.z=0;
			_Cube5.x-=20;
			_ObjectContainer3D.addChild(_Cube5);

			_Cube6=new Cube({width: 5, height: 5, depth: 5});
			_Cube6.material=_MatCube;
			_Cube6.x=0;
			_Cube6.y=40;
			_Cube6.z=0;
			_Cube6.x-=20;
			_ObjectContainer3D.addChild(_Cube6);

			_Cube7=new Cube({width: 5, height: 5, depth: 5});
			_Cube7.material=_MatSelectedCube;
			_Cube7.x=0;
			_Cube7.y=80;
			_Cube7.z=_VerticeZ;
			_Cube7.x-=20;
			_ObjectContainer3D.addChild(_Cube7);

			_Cube8=new Cube({width: 5, height: 5, depth: 5});
			_Cube8.material=_MatCube;
			_Cube8.x=0;
			_Cube8.y=120;
			_Cube8.z=0;
			_Cube8.x-=20;
			_ObjectContainer3D.addChild(_Cube8);

			_Cube9=new Cube({width: 5, height: 5, depth: 5});
			_Cube9.material=_MatCube;
			_Cube9.x=40;
			_Cube9.y=0;
			_Cube9.z=0;
			_Cube9.x-=20;
			_ObjectContainer3D.addChild(_Cube9);

			_Cube10=new Cube({width: 5, height: 5, depth: 5});
			_Cube10.material=_MatCube;
			_Cube10.x=40;
			_Cube10.y=40;
			_Cube10.z=0;
			_Cube10.x-=20;
			_ObjectContainer3D.addChild(_Cube10);

			_Cube11=new Cube({width: 5, height: 5, depth: 5});
			_Cube11.material=_MatCube;
			_Cube11.x=40;
			_Cube11.y=80;
			_Cube11.z=0;
			_Cube11.x-=20;
			_ObjectContainer3D.addChild(_Cube11);

			_Cube12=new Cube({width: 5, height: 5, depth: 5});
			_Cube12.material=_MatCube;
			_Cube12.x=40;
			_Cube12.y=120;
			_Cube12.z=0;
			_Cube12.x-=20;
			_ObjectContainer3D.addChild(_Cube12);

			_Cube13=new Cube({width: 5, height: 5, depth: 5});
			_Cube13.material=_MatCube;
			_Cube13.x=80;
			_Cube13.y=0
			_Cube13.z=0;
			_Cube13.x-=20;
			_ObjectContainer3D.addChild(_Cube13);

			_Cube14=new Cube({width: 5, height: 5, depth: 5});
			_Cube14.material=_MatCube;
			_Cube14.x=80;
			_Cube14.y=40;
			_Cube14.z=0;
			_Cube14.x-=20;
			_ObjectContainer3D.addChild(_Cube14);

			_Cube15=new Cube({width: 5, height: 5, depth: 5});
			_Cube15.material=_MatCube;
			_Cube15.x=80;
			_Cube15.y=80;
			_Cube15.z=0;
			_Cube15.x-=20;
			_ObjectContainer3D.addChild(_Cube15);

			_Cube16=new Cube({width: 5, height: 5, depth: 5});
			_Cube16.material=_MatCube;
			_Cube16.x=80;
			_Cube16.y=120;
			_Cube16.z=0;
			_Cube16.x-=20;
			_ObjectContainer3D.addChild(_Cube16);

			_PatchVerts=new Array(new Vertex(-40, 0, 0), new Vertex(-40, 40, 0), new Vertex(-40, 80, 0), new Vertex(-40, 120, 0), new Vertex(0, 0, 0), new Vertex(0, 40, 0), new Vertex(0, 80, _VerticeZ), new Vertex(0, 120, 0), new Vertex(40, 0, 0), new Vertex(40, 40, 0), new Vertex(40, 80, 0), new Vertex(40, 120, 0), new Vertex(80, 0, 0), new Vertex(80, 40, 0), new Vertex(80, 80, 0), new Vertex(80, 120, 0));

			var PatchInfo:Array=new Array({key: "plane", orientation: null, segmentsW: _SegmentsW, segmentsH: _SegmentsH});

			var PlaneData:PatchData=new PatchData(_PatchNode, _PatchVerts, null, PatchInfo, 1);
			_BezierPatch=new BezierPatch(PlaneData, {name: "plane", material: _Mat, bothsides: true});
			_BezierPatch.x=-20;

			_ObjectContainer3D.scale(1.5);
			_ObjectContainer3D.addChild(_BezierPatch);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_ObjectContainer3D.rotationY+=1;

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_VerticeZ=ThisSlider.getCursorPosition();
					_PatchVerts[6]=new Vertex(0, 80, _VerticeZ);
					_Cube7.z=_VerticeZ / 4;
					_BezierPatch.refreshPatch();
					break;
			}

		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

	}
}