package SGComponents
{
	import away3d.cameras.Camera3D;
	import away3d.containers.Scene3D;
	import away3d.containers.View3D;
	import away3d.core.clip.RectangleClipping;
	
	import flash.display.Sprite;

	public class SingleView extends Sprite
	{
		//public var camera:HoverCamera3D
		public var View:View3D;
		public var Scene:Scene3D;
		public var camera:Camera3D;
		
		
		
		public function SingleView (w:Number,h:Number,x:Number,y:Number,camera:Camera3D)
		{
			// create a camera			
			//camera= new HoverCamera3D({zoom:5, focus:300,distance:2000});	
			
			// create the viewport and attach it to the Sprite so we can mask and move it 
			View = new View3D({scene:Scene,camera:camera,x:w/2,y:h/2});
			var myClip:RectangleClipping = new RectangleClipping({minX:-w/2,minY:-h/2,maxX:w/2,maxY:h/2});
			View.clipping = myClip;
			
			// add a border
			var border:Sprite = makeBorder(w,h);
			addChild(border);
			
			// Add View and position Sprite
			addChild(View);
			this.x = x;
			this.y = y;
		}
		
		private function makeBorder(w:Number,h:Number):Sprite
		{
			var border:Sprite = new Sprite();
			border.graphics.lineStyle(0,0xcccccc);
			border.graphics.drawRect(0,0,w,h);
			return border;
		}
	}
}